---
title: Detecting device orientation
slug: Web/API/Detecting_device_orientation
tags:
  - API
  - Device Orientation
  - Intermediate
  - Mobile
  - Motion
  - Orientation
  - Reference
---
<div>{{SeeCompatTable}}</div>

<p>Increasingly, web-enabled devices are capable of determining their <strong>orientation</strong>; that is, they can report data indicating changes to their orientation with relation to the pull of gravity. In particular, hand-held devices such as mobile phones can use this information to automatically rotate the display to remain upright, presenting a wide-screen view of the web content when the device is rotated so that its width is greater than its height.</p>

<p>There are two JavaScript events that handle orientation information. The first one is the {{domxref("DeviceOrientationEvent")}}, which is sent when the accelerometer detects a change to the orientation of the device. By receiving and processing the data reported by these orientation events, it's possible to interactively respond to rotation and elevation changes caused by the user moving the device.</p>

<p>The second event is the {{domxref("DeviceMotionEvent")}}, which is sent when a change in acceleration was added. It is different from the {{domxref("DeviceOrientationEvent")}} because it is listening for changes in acceleration as opposed to orientation. Sensors that are commonly capable of detecting {{domxref("DeviceMotionEvent")}} include sensors in laptops to protect moving storage devices. {{domxref("DeviceOrientationEvent")}} is more commonly found in mobile devices.</p>

<h2 id="Processing_orientation_events">Processing orientation events</h2>

<p>All you need to do in order to begin receiving orientation change is to listen to the {{event("deviceorientation")}} event:</p>

<div class="note">
<p><strong>Note</strong>: <a href="https://github.com/dorukeker/gyronorm.js">gyronorm.js</a> is a polyfill for normalizing the accelerometer and gyroscope data on mobile devices. This is useful for overcoming some of the differences in device support for device orientation.</p>
</div>

<pre class="brush: js notranslate">window.addEventListener("deviceorientation", handleOrientation, true);
</pre>

<p>After registering your event listener (in this case, a JavaScript function called handleOrientation()), your listener function periodically gets called with updated orientation data.</p>

<p>The orientation event contains four values:</p>

<ul>
 <li>{{domxref("DeviceOrientationEvent.absolute")}}</li>
 <li>{{domxref("DeviceOrientationEvent.alpha")}}</li>
 <li>{{domxref("DeviceOrientationEvent.beta")}}</li>
 <li>{{domxref("DeviceOrientationEvent.gamma")}}</li>
</ul>

<p>The event handler function can look something like this:</p>

<pre class="brush: js notranslate">function handleOrientation(event) {
  var absolute = event.absolute;
  var alpha    = event.alpha;
  var beta     = event.beta;
  var gamma    = event.gamma;

  // Do stuff with the new orientation data
}
</pre>

<h3 id="Orientation_values_explained">Orientation values explained</h3>

<p>The value reported for each axis indicates the amount of rotation around a given axis in reference to a standard coordinate frame. These are described in greater detail in the <a href="/en-US/DOM/Orientation_and_motion_data_explained">Orientation and motion data explained</a> article which is summarized below.</p>

<ul>
 <li>The {{domxref("DeviceOrientationEvent.alpha")}} value represents the motion of the device around the z axis, represented in degrees with values ranging from 0 (inclusive) to 360 (exclusive).</li>
 <li>The {{domxref("DeviceOrientationEvent.beta")}} value represents the motion of the device around the x axis, represented in degrees with values ranging from -180 (inclusive) to 180 (exclusive). This represents a front to back motion of the device.</li>
 <li>The {{domxref("DeviceOrientationEvent.gamma")}} value represents the motion of the device around the y axis, represented in degrees with values ranging from -90 (inclusive) to 90 (exclusive). This represents a left to right motion of the device.</li>
</ul>

<h3 id="Orientation_example">Orientation example</h3>

<p>This example will work on any browser supporting the {{event("deviceorientation")}} event and running on a device able to detect its orientation.</p>

<p>So let's imagine a ball in a garden:</p>

<pre class="brush: html notranslate">&lt;div class="garden"&gt;
  &lt;div class="ball"&gt;&lt;/div&gt;
&lt;/div&gt;

&lt;pre class="output"&gt;&lt;/pre&gt;
</pre>

<p>This garden is 200 pixel wide (Yes, it's a tiny one), and the ball is in the center:</p>

<pre class="brush: css notranslate">.garden {
  position: relative;
  width : 200px;
  height: 200px;
  border: 5px solid #CCC;
  border-radius: 10px;
}

.ball {
  position: absolute;
  top   : 90px;
  left  : 90px;
  width : 20px;
  height: 20px;
  background: green;
  border-radius: 100%;
}
</pre>

<p>Now, if we move our device, the ball will move accordingly:</p>

<pre class="brush: js notranslate">var ball   = document.querySelector('.ball');
var garden = document.querySelector('.garden');
var output = document.querySelector('.output');

var maxX = garden.clientWidth  - ball.clientWidth;
var maxY = garden.clientHeight - ball.clientHeight;

function handleOrientation(event) {
  var x = event.beta;  // In degree in the range [-180,180)
  var y = event.gamma; // In degree in the range [-90,90)

  output.textContent  = `beta : ${x}\n`;
  output.textContent += `gamma: ${y}\n`;

  // Because we don't want to have the device upside down
  // We constrain the x value to the range [-90,90]
  if (x &gt;  90) { x =  90};
  if (x &lt; -90) { x = -90};

  // To make computation easier we shift the range of
  // x and y to [0,180]
  x += 90;
  y += 90;

  // 10 is half the size of the ball
  // It center the positioning point to the center of the ball
  ball.style.top  = (maxY*y/180 - 10) + "px";
  ball.style.left = (maxX*x/180 - 10) + "px";
}

window.addEventListener('deviceorientation', handleOrientation);
</pre>

<p>{{LiveSampleLink("Orientation_example", "Click here")}} to open this example in a new window; because {{event("deviceorientation")}} doesn't work in a cross-origin {{HTMLElement("iframe")}} in all browsers.</p>

<div>{{EmbedLiveSample('Orientation_example', '230', '260')}}</div>

<h2 id="Processing_motion_events">Processing motion events</h2>

<p>Motion events are handled the same way as the orientation events except that they have their own event's name: {{event("devicemotion")}}</p>

<pre class="brush: js notranslate">window.addEventListener("devicemotion", <em>handleMotion</em>, true);</pre>

<p>What's really changed are the information provided within the {{domxref("DeviceMotionEvent")}} object passed as a parameter of the <em>HandleMotion</em> function.</p>

<p>The motion event contains four properties:</p>

<ul>
 <li>{{domxref("DeviceMotionEvent.acceleration")}}</li>
 <li>{{domxref("DeviceMotionEvent.accelerationIncludingGravity")}}</li>
 <li>{{domxref("DeviceMotionEvent.rotationRate")}}</li>
 <li>{{domxref("DeviceMotionEvent.interval")}}</li>
</ul>

<h3 id="Motion_values_explained">Motion values explained</h3>

<p>The {{domxref("DeviceMotionEvent")}} objects provide web developers with information about the speed of changes for the device's position and orientation. The changes are provided along three axis (see <a href="/en-US/docs/Web/Guide/DOM/Events/Orientation_and_motion_data_explained">Orientation and motion data explained</a> for details).</p>

<p>For {{domxref("DeviceMotionEvent.acceleration","acceleration")}} and {{domxref("DeviceMotionEvent.accelerationIncludingGravity","accelerationIncludingGravity")}}, those axes correspond to the following:</p>

<ul>
 <li><code>x</code>: Represents the axis from West to East</li>
 <li><code>y</code>: Represents the axis from South to North</li>
 <li><code>z</code>: Represents the axis perpendicular to the ground</li>
</ul>

<p>For {{domxref("DeviceMotionEvent.rotationRate","rotationRate")}}, the situation is a bit different; the information corresponds to the following in each case:</p>

<ul>
 <li><code>alpha</code>: Represents a rotation rate along the axis perpendicular to the screen (or keyboard for desktop).</li>
 <li><code>beta</code>: Represents a rotation rate along the axis going from left to right of the plane of the screen (or keyboard for desktop).</li>
 <li><code>gamma</code>: Represents a rotation rate along the axis going from bottom to top of the plane of the screen (or keyboard for desktop).</li>
</ul>

<p>Finally, {{domxref("DeviceMotionEvent.interval","interval")}} represents the interval of time, in milliseconds, at which data are obtained from the device.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Device Orientation')}}</td>
   <td>{{Spec2('Device Orientation')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="DeviceMotionEvent"><code>DeviceMotionEvent</code></h3>

<p>{{Compat("api.DeviceMotionEvent")}}</p>

<h3 id="DeviceOrientationEvent"><code>DeviceOrientationEvent</code></h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.DeviceOrientationEvent")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("DeviceOrientationEvent")}}</li>
 <li>{{domxref("DeviceMotionEvent")}}</li>
 <li>The legacy <code><a href="/en-US/docs/Web/Events/MozOrientation">MozOrientation</a></code> event.</li>
 <li><a href="/en-US/docs/Web/Guide/DOM/Events/Orientation_and_motion_data_explained">Orientation and motion data explained</a></li>
 <li><a href="/en-US/docs/Web/Guide/DOM/Events/Using_device_orientation_with_3D_transforms">Using deviceorientation in 3D Transforms</a></li>
 <li><a href="/en-US/docs/Games/Workflows/HTML5_Gamedev_Phaser_Device_Orientation">Cyber Orb: 2D maze game with device orientation</a></li>
</ul>
